!!!!!!!!!!!!!!!!!!!!!!!
subroutine LensGraphics(lout)
  use aberrat !most
  use console,only: KON
  use options,only: LocateOption,mods
  include 'precisn.fh'
  intent(in) lout
!
! drawing, fans, and field plots
!
  logical plotit,SurfaceFailure,sym
  character(17) str(0:5); character(85) strs; equivalence (str(1),strs)
  character(*),parameter :: FMT='(a,:,1x,f0.4)'
!  parameter (DY=.625,YH=2*(2*DY+.1),YP=(8+YH)/2)
  dimension ys(mFB),xd(mSUR),yd(2,mSUR)
  parameter (M=60) !evenly divisible by any number of fields up to 6
  dimension yr(-M:M,mFB),yw(0:2,-M:M,mFB),xw(0:2,-M:M,mFB),sr(0:M),tr(0:M),sw(0:2,0:M),pw(0:2,0:M),tw(0:2,0:M) &
   ,dr(0:M),dc(0:M),dw(0:2,0:M),rs(0:M),bs(0:M),gs(0:M),qs(0:m)
  parameter (SMALL=.0001,DEL=ONE/M)
  integer,parameter :: iCLR(-1:2)=(/1,13,2,11/)+4 !black,green,red,blue
  logical ends,opd,ds0
  ends(j)=j==1.or.j==nf.or.abs(vig(0))>.1
  include 'finite.fi'
  frac(j)=j*DEL
  round(x)=sign(smal*(aint(abs(x)/smal)+1),x)
  plotit(j)=mod(j,n)==0
    ds0=mods(LocateOption('DS'))=='0'
    DY=merge(.5,.625,nf>5); YH=2*(2*DY+.1); YP=(8+YH)/2
    n=M/(mFB+1-nf); fbm=ZERO; if (fb(1)*fb(nf)>0) fbm=minval(abs(fb(:nf)))
    fbx=maxval(abs(fb(:nf))); ob(ns+1)=ZERO; if (fbm>0) o=BIG
    mth=-1; k0=0; if (rstop) k0=abs(kth(0))-1
    if (ns>1.and.all(mg(1:ns)>=0).and.gwin==ZERO) then !don't plot "long" airspace?
      mth=maxloc(th(1:ns-1),1,rn(mg(1:ns-1))==ONE); if (th(mth)<sum(th(1:ns))/2) mth=-1
    endif
! setup lens plot
    call Write2Plot(.4_KR,.4_KR,-iCLR(-1)); y0=ZERO; t0=th(0); if (u0>=TENTH.or.h1/max(u0,HUNTH)<t0) t0=t0-h1/max(u0,HUNTH)
    x=min(t0,ZERO); x1=x; x2=x; x=ZERO
    do i=0,ns
      j=i+1; y0=max(y0,abs(ap(j)),sd(j)); if (i/=mth) x=x+th(i); if (i==ns) x=x+th(ns+1)
      sf=.5*cv(j)*ap(j)**2; x1=min(x1,x,x+sf); x2=max(x2,x,x+sf)
    enddo !i
    kf=1; if (gwin<ZERO.and.nf>2) kf=nf-1
    x0=10; if (nf>2.and.kf==1) x0=6.5
    dx=max(abs(gwin),x2-x1); sf=min(x0/dx,(YP-YH-.6)/y0); x0=(x0-sf*dx)/2; ym=abs(targ); if (nf>2.and.kf==1) x0=x0+3.5
    xg=x0+sf*(glth(2)-x1)
    if (xg<=10) then
      call Write2Plot(x0-sf*x1,yh+.5,3); call Write2Plot(xg,yh+.5,2)
    endif
    u=om/GlassIndex(ns); opd=wv>ZERO.and.just<0.and.mord<4; i1=max(0,min(mord,1)); klr=min(kolr,2); i2=abs(klr)
! setup oversized lens edges
    x=th(0); yd=reshape((/(TEN,ZERO,j=1,mSUR)/),(/2,mSUR/))
    do i=1,merge(ns,0,fbm==ZERO.or.just>=0)
      y=sd(i); z=SurfaceSag(i,y); xd(i)=x0+sf*(x+z-x1); yd(1,i)=-sf*y+YP; yd(2,i)=sf*y+YP; if (i/=mth) x=x+th(i)
    enddo !i
! loop thru fields
    do k=1,nf
      js=-1; ys(k)=ZERO; h=fb(k); sym=(fbm==ZERO.or.just>=0).and.h/=ZERO
      dum=YrayDeviation(-ONE,h); if (opd) dum=WaveDeviation(-ONE,h)
      do j=-M,M
        r=frac(j)
! opd or transverse ray error from aberration coefficients
        r2=r*r
        if (opd) then; yw(0,j,k)=WaveDeviation(r2,r)
                 else; yw(0,j,k)=YRayDeviation(r2,r); endif
        if (j<0) then
          xw(0,j,k)=YrayDeviation(r2,ZERO) !used later to up clear aperture
        elseif (opd) then
          xw(0,j,k)=WaveDeviation(r2,ZERO)
        else
          xw(0,j,k)=XrayDeviation(r,0)
        endif
        do i=1,i2
          if (opd) then; e=r2*(w020c(i)+w040c(i)*r2); yw(i,j,k)=e+w111c(i)*h*r
                   else; e=r*(2*w020c(i)+4*w040c(i)*r2); yw(i,j,k)=e+w111c(i)*h; endif
          yw(i,j,k)=yw(i,j,k)+yw(0,j,k); xw(i,j,k)=e+xw(0,j,k)
        enddo !i
! from real ray
        x=th(0); call RayStart(1,r,h,y,v,w,s,t); v0=v; w0=w; line=-1
        do i=1,ns+1
          call SurfaceSetup(i); if (SurfaceFailure(s,t,y,1,z,v,w)) exit
          if (i/=mth) x=x+z
          if (abs(r)>=obsr.and.abs(y)>=ob(i)*abs(ap(i))) then
            y0=y
            if (plotit(j)) then
              if (i==1) then
                if (u0>=TENTH.or.h1/max(u0,HUNTH)<th(0)) then
                  ep=h1/max(u0,HUNTH); ep=sf*(ep+z)/w0 !object plane
                else
                  ep=th(0); ep=min(max(ZERO,ep),th(0)-x1) ! ep=max(ZERO,th(0)) !old way
                  ep=sf*(ep+z)/w0; ep=max(.1_KR,ep)
                endif
                call Write2Plot(x0+sf*(x-x1)-ep*w0,sf*y0-ep*v0+YP,iCLR(0))
              endif
              call splots(x0+sf*(x-x1),sf*y0+YP,i*line); line=-1
              if (ends(k).and.sym) call splots(x0+sf*(x-x1),-sf*y0+YP,mSUR+i) !no plot
            elseif (ends(k)) then
              call splots(x0+sf*(x-x1),sf*y0+YP,i); if (sym) call splots(x0+sf*(x-x1),-sf*y0+YP,i)
            endif
          else
            line=1 !point
          endif
          if (i>ns) exit
          if (i/=abs(kth(0))) then
            ap(i)=max(SMALL,ap(i),abs(y))
          elseif (js/=0) then
            if (js<0) then
              js=-js; ys(k)=y
            elseif (y*ys(k)<=ZERO) then
              js=0; ys(k)=(j-y/(y-ys(k)))/m
            else
              ys(k)=y
            endif
          endif
          d=th(i)-z; if (i==ns) d=d+th(ns+1)
          if (i/=mth) x=x+d
          call TransferRay(i,s,t,y,1,v,d/w); if (k0==i) call ReadjustatStop(r*ap(i+1),s,t,v,w,y)
        enddo !i
        yr(j,k)=y; yx=y; if (j>0) yx=yr(0,k)+xw(0,-j,k)
        ap(i)=max(SMALL,ap(i),abs(y),abs(yx)); if (fbm>0) o=min(o,abs(y),abs(yx))
      enddo !j
      js=max(-M,min(nint(ys(k)*M),M)); y0=yr(js,k); w0=yw(0,js,k)
      do j=-M,M
        yr(j,k)=yr(j,k)-y0; yw(0,j,k)=yw(0,j,k)-w0
        if (opd) then
          yw(:i2,j,k)=yw(:i2,j,k)*om/wvs(:i2); xw(:i2,j,k)=xw(:i2,j,k)*om/wvs(:i2)
          ym=max(ym,abs(yw(0,j,k))); if (j>0) ym=max(ym,abs(xw(0,j,k)))
        else
          ym=max(ym,abs(yr(j,k)))
          if (kolr==3) then
            r=frac(j)
            do kwl=2,1,-1
              yw(kwl,j,k)=FinalYofRay(r,h)-y0; ym=max(ym,abs(yw(kwl,j,k)))
              if (j>0.and.mord>3) xw(kwl,j,k)=FinalXofRay(r,h)
            enddo !kwl
            if (j>0.and.mord>3) xw(0,j,k)=FinalXofRay(r,h)
          endif
        endif
        if (just==0) cycle
        do i=i1,i2
          ym=max(ym,abs(yw(i,j,k))) !,abs(xw(i,j,k)))
        enddo !i
      enddo !j
      if (nf<=-1.and.fb(1)==ZERO.and.th(ns+1)==ZERO) then !disabled by minus
! caustic curve
        x2=th(0)
        do i=1,ns
          x2=x2+th(i)
        enddo !i
        cy3=-8*w040; cz2=-12*w040/u; call CausticTerms(t,v,w,y)
        do l=0,1
          ip=iCLR(-1)
          do j=0,M
            r=frac(j); r2=r*r; y0=r2*(cy3*r+cy4*r2); x=r2*(cz2+cz3*r+cz4*r2)+x2; call Write2Plot(x0+sf*(x-x1),sf*y0+YP,ip); ip=2
          enddo !j
          cy4=ZERO; cz3=ZERO; cz4=ZERO
        enddo !l
      endif
    enddo !k
! field curvs
    smal=merge(1.E-2,1.E-4,opd); ym=round(ym); k=mod(kolr,3); qs=ZERO
    fm=ZERO; dm=mod(abs(dist),ONE); rm=abs(targ); mf=min(nint(fbx*M),M); if (hbf==ZERO.or.mf==0) mf=1
    do j=0,mf
      h=frac(j)
      if (opd) then
        rs(j)=sqrt(RMSwaveFront2((/h/),(/ONE,ONE/),1,k,1))*abs(om/wv); bs(j)=sqrt(RMSwaveFront2((/h/),(/ONE,ONE/),1,0,0))*abs(om/wv)
      else
        rs(j)=sqrt(RMSspotSize2((/h/),(/ONE,ONE/),1,k,1)); bs(j)=+sqrt(RMSspotSize2((/h/),(/ONE,ONE/),1,0,0))
        if (mord>3) qs(j)=sqrt(RealSpotSize2(mord-1,(/h/),(/ONE/),1,dc(j)))
      endif
      h2=h*h; h4=h2*h2; h6=h2*h4; fw=-2*(w020f+w220f*h2+w420f*h4+w620f*h6)/u; sw(0,j)=-2*(w220*h2+w420*h4+w620*h6)/u
      tw(0,j)=-2*(w222*h2+w422*h4+w622*h6)/u; pw(0,j)=1.5*sw(0,j)-tw(0,j)+fw; tw(0,j)=tw(0,j)+sw(0,j)+fw; sw(0,j)=sw(0,j)+fw
      do i=1,i2
        fw=-2*w020c(i)/u; pw(i,j)=pw(0,j)+fw; tw(i,j)=tw(0,j)+fw; sw(i,j)=sw(0,j)+fw
      enddo !i
      dw(:,j)=ZERO; if (mord<4) dc(j)=ZERO
      if (hbf/=ZERO.and.dist>ZERO) then
        dw(0,j)=((w311f+w311)*h2+w511*h4+w711*h6)/hbf
        do i=1,i2
          dw(i,j)=dw(0,j)+w111c(i)/hbf
        enddo !i
        if (mord<4) dc(j)=(w131+w151+w171+(w311f+w311+w331+3*w333/4)*h2+w511*h4+w711*h6)/hbf
      endif
      if (mord<4) call upmax(dc(j),dm)
      if (kolr/=0.or.mord==0) then
        do i=1,i2
          call upmax(dw(i,j),dm); fm=max(fm,abs(sw(i,j)),abs(tw(0,j))) !,abs(pw(i,j)))
        enddo !i
      endif
      x=th(0); call RayStart(1,yLagrangeInterp(h,nf,fb,ys),h,y,v,w,s,t); v0=v; w0=w
      do i=1,ns+1
        call SurfaceSetup(i); if (SurfaceFailure(s,t,y,1,z,v,w)) exit
        if (i/=mth) x=x+z
        if (h>=fbm.and.abs(y)>=ob(i)*abs(ap(i))) then
          y0=y; call splots(x0+sf*(x-x1),sf*y0+YP,i); if (fbm==ZERO) call splots(x0+sf*(x-x1),-sf*y0+YP,i)
        endif
        if (i>ns) exit
        d=th(i)-z; if (i==ns) d=d+th(ns+1)
        if (i/=mth) x=x+d
        call TransferRay(i,s,t,y,1,v,d/w); if (k0==i) call ReadjustatStop(ZERO,s,t,v,w,y)
      enddo !i
      sr(j)=ONE/finite(s); tr(j)=ONE/finite(t); dr(j)=ZERO
      if (h/=ZERO) then
        z=th(ns+1)+z; hf=merge(h*(hbf+z*ubf),v0*(efl+z/w0),dist>ZERO)
        if (hf/=ZERO) then
          dr(j)=y/hf-ONE; if (mord>3) dc(j)=(dc(j)+y)/hf-ONE
        endif
      endif
      rm=max(rm,rs(j),-bs(j),qs(j)); call upmax(dr(j),dm); fm=max(fm,abs(sr(j)),abs(tr(j))); if (mord>3) call upmax(dc(j),dm)
    enddo !j
    if (dist<ZERO.and.frac(0)==ZERO) dr(0)=dr(1)
    call splots(ZERO,ZERO,0); smal=1.D-4; fm=round(fm); smal=merge(1.E-6,1.E-5,opd); rm=round(rm); smal=1.D-5; dm=round(dm)
! plot fans
    l=max(1,3-nf); sf=l*DY/ym; ys=ZERO; xa=1.6; str(0)=dim; str(5)=' '; ky=0
    if (opd) then; write(str(1),FMT(:11)//'2)',iostat=i) 'OPDwaves',ym
             else; write(str(1),FMT,iostat=i) 'RayFans',ym; endif
    do k=1,nf,kf
! axes
      ky=ky+1; y0=.3+2*(l*DY+.1)*(ky-.5); call hline(xa-1.6,y0,xa+1.6); call vline(y0-l*DY,xa,y0+l*DY)
      if (ym>=abs(targ)) then
        do i=-1,1,2
          x=y0+abs(targ)*i*sf; call hline(xa-.05,x,xa+.05) !tic
        enddo !i
      endif
! real rays
      ip=iCLR(0)
      do j=merge(M,-M,opd),M
        x=1.6*(frac(j)-ys(k))+xa; call Write2Plot(x,y0+yr(j,k)*sf,ip); ip=2
      enddo !j
      if (just==0) cycle
      if (fb(k)/=ZERO.and.just<0) then
        call Write2Plot(x+.05,y0+merge(yw(0,M,k),yr(M,k),opd)*sf-.1,ichar('T'))
! polynomials
        do i=0,i2
          ip=iCLR(i)
          do j=1,M
            x=1.6*frac(j)+xa; call Write2Plot(x,y0+xw(i,j,k)*sf,ip); ip=5-min(ip,3) !dash
          enddo !j
        enddo !i
        call Write2Plot(x+.05,y0+xw(0,M,k)*sf-.1,ichar('S'))
      endif
      do i=0,i2
        ip=iCLR(i)
        do j=-M,M
          x=1.6*(frac(j)-ys(k))+xa; !if (abs(frac(j))>=obsr) &
           call Write2Plot(x,y0+yw(i,j,k)*sf,ip); ip=1; if (i>0.or.opd) ip=2
        enddo !j
      enddo !i
    enddo !k
! plot field curves
    xa=axes(3,'FieldCrv',fm)
    ip=iCLR(0)
    do j=0,mf
      y0=.3+YH*frac(j); call Write2Plot(xa+sr(j)/fm,y0,ip); ip=2
    enddo !j
    call Write2Plot(xa+sr(mf)/fm,y0,ichar('S'))
    ip=3
    do j=0,mf
      y0=.3+YH*frac(j); call Write2Plot(xa+tr(j)/fm,y0,ip); ip=2
    enddo !j
    call Write2Plot(xa+tr(mf)/fm,y0,ichar('T'))
    do i=0,i2
      ip=iCLR(i)
      do j=0,merge(mf,2,kolr<3)
        y0=.3+YH*frac(j); if (frac(j)>=fbm) call Write2Plot(xa+sw(i,j)/fm,y0,ip); ip=1+min(i,1)
      enddo !j
      ip=3
      do j=0,merge(mf,2,kolr<3)
        y0=.3+YH*frac(j); if (frac(j)>=fbm) call Write2Plot(xa+tw(i,j)/fm,y0,ip); ip=1+min(i,1)
      enddo !j
    enddo !i
!    ip=3
!    do j=0,mf
!      y0=.3+YH*frac(j); call Write2Plot(xa+pw(0,j)/fm,y0,ip); ip=2
!    enddo !j
!    call Write2Plot(xa+pw(0,mf)/fm,y0,ichar('P'))
! plot distortion curves
    xa=axes(4,'%Distort',dm,2); dm=abs(dm)
    if (dm>=abs(dist)) then
      do i=-1,1,2
        x=xa+dist*i/dm; call vline(.3_KR,x,.4_KR) !tic
      enddo !i
    endif
    ip=iCLR(0)
    do j=0,mf
      y0=.3+YH*frac(j); call Write2Plot(xa+dr(j)/dm,y0,ip); ip=2
    enddo !j
!    call Write2Plot(xa+dr(mf)/dm,y0,ichar('P')) !D'))
    if (dist>ZERO) then
      ip=3
      do j=0,mf
        y0=.3+YH*frac(j); call Write2Plot(xa+dc(j)/dm,y0,ip); ip=2
      enddo !j
      call Write2Plot(xa+dc(mf)/dm,y0,ichar('C'))
      do i=0,i2
        ip=iCLR(i)
        do j=0,merge(mf,2,kolr<3)
          y0=.3+YH*frac(j); if (frac(j)>=fbm) call Write2Plot(xa+dw(i,j)/dm,y0,ip); ip=1+min(i,1)
        enddo !j
      enddo !i
    endif
    str(2)=' '
    if (just<0) then
! plot RMS curves
      if (kolr==3) then
        gs(0:mf)=rs(0:mf)
        do kwl=2,1,-1
          bs(0:mf)=rs(0:mf); i=mord; call Aberrations(i,0); w111=ZERO
          do j=0,mf
            h=frac(j)
            if (opd) then; rs(j)=sqrt(RMSwaveFront2((/h/),(/ONE,ONE/),1,0,1))*abs(om/wv)
                     else; rs(j)=sqrt(RMSspotSize2((/h/),(/ONE,ONE/),1,0,1)); endif
            rm=max(rs(j),rm)
          enddo !j
        enddo !kwl
        i=mord; call Aberrations(i,0)
      endif
      if (opd) then; xa=axes(2,'RMSwaves',rm,-2)
               else; xa=axes(2,'RMSx1000',rm,3); endif
      if (rm>=abs(targ)) then
        do i=-1,1,2
          x=xa+abs(targ)*i/rm; call vline(.3_KR,x,.4_KR) !tic
        enddo !i
      endif
      ip=iCLR(0)
      do j=0,merge(mf,-1,mord>3.and..not.opd)
        y0=.3+YH*frac(j); call Write2Plot(xa+qs(j)/rm,y0,ip); ip=2
      enddo !j
      ip=iCLR(0)
      do j=0,merge(mf,-1,kolr==3)
        y0=.3+YH*frac(j); call Write2Plot(xa+gs(j)/rm,y0,ip); ip=2
      enddo !j
      ip=iCLR(merge(1,i2,kolr==3))
      do j=0,mf
        y0=.3+YH*frac(j); call Write2Plot(xa+rs(j)/rm,y0,ip); ip=2
      enddo !j
!      call Write2Plot(xa+rs(mf)/rm,y0,ichar('A'))
      ip=iCLR(merge(2,0,kolr==3))
      do j=0,mf
        y0=.3+YH*frac(j); call Write2Plot(xa+bs(j)/rm,y0,ip); ip=2
      enddo !j
!      call Write2Plot(xa+bs(mf)/rm,y0,ichar('B'))
    endif
! finish up
    call Write2Plot(.1_KR,.05_KR,iCLR(-1))
    do i=merge(0,1,str(0)/=' '),4
      call Write2Plot(max(.1_KR,.9+2.3_KR*(i-1)),.05_KR,127); call PlotString(trim(str(i)))
    enddo !i
    if (fbm>0) ob(ns+1)=o/ap(ns+1)
    if (lout>0) then
      call PrintLens(' Final'); l=len_trim(strs); l=KompressBlanks(strs(:l))
      write(KON,'(2(1x,a))') 'Max aberrations:',strs(:l); write(KON,*)
    endif
    call multiplot
    call Write2Plot(ZERO,ZERO,999)
  return
contains
  !!!!!!!!!!!!!!!!
  subroutine upmax(x,y) !signed maximum
  intent(in) x; intent(inout) y
    if (abs(x)>abs(y)) y=x
  end subroutine
  !!!!!!!!!!!!!!!!!
  subroutine splots(x,y,i)
  include 'default.fh'
  intent(in) x,y,i
  integer ip,j,k,l !local
  integer,save :: n=0
  real(KR),dimension(2,mSUR),save :: xs,ys=reshape((/(TEN,ZERO,j=1,mSUR)/),(/2,mSUR/))
  logical j2,air; air(k)=abs(GlassIndex(k))==ONE
    if (i==0) then
      ip=iCLR(2)
      do k=1,n-1
        if (air(k)) cycle
        do j=1,2
          call Write2Plot(xs(j,k),ys(j,k),ip); j2=j==2; l=2*j-3 !=0 to turn off
          if (l*yd(j,k)>l*ys(j,k).and.l*yd(j,k+1)>l*ys(j,k+1)) then
            call Write2Plot(xd(k),yd(j,k),2)
            if (yd(j,k)>yd(j,k+1).eqv.j2) then; call Write2Plot(xd(k+1),yd(j,k),2)
                                          else; call Write2Plot(xd(k),yd(j,k+1),2); endif
            call Write2Plot(xd(k+1),yd(j,k+1),2)
          elseif (ys(j,k)>ys(j,k+1).eqv.j2) then
            call Write2Plot(xs(j,k+1),ys(j,k),2)
          else
            call Write2Plot(xs(j,k),ys(j,k+1),2)
          endif
          call Write2Plot(xs(j,k+1),ys(j,k+1),2); ip=3
        enddo !j
      enddo !k
      do k=1,n
        ys(1,k)=TEN; ys(2,k)=ZERO
      enddo !k
      n=0
    else
      j=mod(abs(i)-1,mSUR)+1; n=max(n,j)
      if (y<ys(1,j)) then
        xs(1,j)=x; ys(1,j)=y
      endif
      if (y>ys(2,j)) then
        xs(2,j)=x; ys(2,j)=y
      endif
      if (abs(i)>mSUR) return
      if (i<0) then
        call Write2Plot(x,y,2)
      elseif (i>0) then
        if (ds0) then
          if (i<=ns) then
            if (i/=abs(kth(0))) then
              if (GlassIndex(i-1)==GlassIndex(i)) return !dummy
            endif
          endif
        endif
        call Write2Plot(x,y,1)
      endif
    endif
  end subroutine
  !!!!!!!!!!!!!
  function axes(j,lab,val,mag) result(x)
  intent(in) j,lab,val,mag; character(*) lab; optional mag
    x=2+2.3*(j-1)
    if (present(mag)) then; write(str(j),FMT(:11)//char(53-abs(mag))//')',iostat=idum) lab,val*TEN**max(0,mag) !52-mag
                      else; write(str(j),FMT,iostat=idum) lab,val; endif
    do k=1,nf
      y0=.3+abs(fb(k))*YH; call hline(x-.05,y0,x+.05) !tic
    enddo !k
    call hline(x-1,.3_KR,x+1); call vline(.3+YH,x,.3_KR)
  end function
  !!!!!!!!!!!!!!!!
  subroutine hline(x1,y,x2)
  intent(in) x1,y,x2
    call Write2Plot(x1,y,iCLR(-1)); call Write2Plot(x2,y,2)
  end subroutine
  !!!!!!!!!!!!!!!!
  subroutine vline(y1,x,y2)
  intent(in) y1,x,y2
    call Write2Plot(x,y1,iCLR(-1)); call Write2Plot(x,y2,2)
  end subroutine
  !!!!!!!!!!!!!!!!!!!!
  subroutine multiplot
  use options,only: LocateOption,GNP,ignp,lgnp
  dimension p(2) !,l(3)
  character(*),parameter :: FMT1="(f0.6,1x,f0.3)"
  character(*),parameter :: FMT2="(f0.3,1x,f0.6)"
    if (LocateOption('GP')<1) return
    lu=LogicalUnit(0); open(lu,file='aberrations.gnp',action='write',status='replace')
!    include 'mulplot.fi'
    if (just<0) then
! separate zone(spot) diagram
      call WriteHead(lu); write(lu,*) 'set zeroaxis;set key outside;set size ratio -1;set style data linespoints'
      write(lu,*) 'set xlabel "'//trim('x '//dim)//'";set ylabel "'//trim('y '//dim)//'"'
      y=ZERO; n=0; if (mord>3.and.kolr==3) n=2
      write(lu,'(a)') 'set title "'//merge(' ','~',mord>3)//'Displacements relative to max-field chief ray for given ' &
        //merge('pupil zones"','wavelengths"',n==0)
      write(lu,*) 'set colorseq classic'
      if (n==2) then; write(lu,'(3(a,f0.4))') "plot '-' lt 2 t'",wvl(0),"', '-' lt 1 t'",wvl(1),"', '-' lt 3 t'",wvl(-1)
                else; write(lu,'(10a)') "plot '-' t'1.0'",(", '-' t'0."//char(48+j)//"'",j=9,1,-1); endif
!ns=-ns !enp diagram
      if (mord>3) then; call FinalPofRay((/ZERO,ZERO/),fbx,p); if (ns>0) y=p(1)
                  else; dum=YrayDeviation(ZERO,fbx); endif
      do kwl=0,n
        do j=10,1,-1
          r=j/TEN; r2=r*r
          do i=0,6*j
            a=i*PI/(3*j)
            if (mord<=3) then; p(1)=YrayDeviation(r2,r*cos(a)); p(2)=XrayDeviation(r*sin(a),1)
                         else; call FinalPofRay(r*(/cos(a),sin(a)/),fbx,p); p(1)=p(1)-y; endif
            write(lu,'(2(1x,f0.6))') p(2),p(1)
          enddo !i
          write(lu,*) merge('e',' ',n==0)
        enddo !j
        if (n==2) write(lu,*) 'e'
      enddo !kwl
      kwl=0; call WritePause(lu)
    endif
    close(lu); call UserProcess(' ','aberrations.gnp'); ns=abs(ns)
  end subroutine
end
